package com.totopia.server.modules.user.controller;

import com.totopia.server.commons.exception.ResourceNotFoundException;
import com.totopia.server.modules.user.entity.UserEntity;
import com.totopia.server.modules.user.repository.UserRepository;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.data.domain.*;
import org.springframework.data.web.SortDefault;
import org.springframework.http.HttpStatus;
import org.springframework.http.ResponseEntity;
import org.springframework.security.core.session.SessionRegistry;
import org.springframework.web.bind.annotation.*;

import java.util.ArrayList;
import java.util.List;
import java.util.stream.Collectors;

@RestController
public class UserController {
  @Autowired
  private UserRepository userRepository;

//  @Autowired
//  private SessionRegistry sessionRegistry;

  @PostMapping(value = "/users")
  @ResponseStatus(code = HttpStatus.CREATED)
  public UserEntity save(@RequestBody UserEntity user) {
    return userRepository.save(user);
  }

  @GetMapping(value = "/users")
  public Page<UserEntity> all(@RequestParam(value = "username", required = false) String username,
                              @SortDefault.SortDefaults({ @SortDefault(sort = "createdAt", direction = Sort.Direction.DESC) }) Pageable pageable) {

    if (null == username) {
      return userRepository.findAll(pageable);
    } else {
      return userRepository.findByUsernameContainingIgnoreCase(username, pageable);
    }
  }

  @GetMapping(value = "/connect-users")
  public Page<UserEntity> connectUsers(@RequestParam(value = "username", required = false) String username,
                              @SortDefault.SortDefaults({ @SortDefault(sort = "createdAt", direction = Sort.Direction.DESC) }) Pageable pageable) {
//    final List<String> curUsers = sessionRegistry.getAllPrincipals().stream()
//            .filter(u -> !sessionRegistry.getAllSessions(u, false).isEmpty())
//            .map(Object::toString)
//            .collect(Collectors.toList());
//
//    long start = pageable.getOffset();
//    long end = (start + pageable.getPageSize()) > curUsers.size() ? curUsers.size() : (start + pageable.getPageSize());
//    List<String> tempUsers = curUsers.subList((int)start, (int)end);
//    List<UserEntity> users = new ArrayList<>();
//
//    for (String conUser : tempUsers) {
//      UserEntity tempUser = this.userRepository.findByUsername(conUser).orElse(null);
//      if(tempUser != null) {
//        users.add(tempUser);
//      }
//    }
//    return new PageImpl<UserEntity>(users, new PageRequest(pageable.getPageNumber(), pageable.getPageSize()), users.size());
    return null;
  }
    @GetMapping(value = "/users/{userId}")
  public UserEntity findByUserId(@PathVariable Long userId) {
    return userRepository.findById(userId).orElseThrow(() -> new ResourceNotFoundException("User", "userId", userId));
  }

  @DeleteMapping(value = "/users/{userId}")
  public ResponseEntity<?> deleteUser(@PathVariable Long userId) {

    return userRepository.findById(userId).map(user -> {
      userRepository.delete(user);
      return ResponseEntity.ok().build();
    }).orElseThrow(() -> new ResourceNotFoundException("User", "userId", userId));

  }

  @PutMapping(value = "/users/{userId}")
  public ResponseEntity<UserEntity> updateUser(@PathVariable Long userId, @RequestBody UserEntity newUser) {

    return userRepository.findById(userId).map(user -> {

      userRepository.save(user);
      return ResponseEntity.ok(user);
    }).orElseThrow(() -> new ResourceNotFoundException("User", "userId", userId));

  }


}
